Description

Occasional intermittent failures are occurring in this test:

HostJSTest::hosts index multiple actions.test_0001_show action buttons (from HostJSTest__hosts ind

ex multiple actions)

Took 42 sec.

Failed assertion, no message given. (Minitest::Assertion)

/var/lib/workspace/workspace/test_develop_pr_core_integration_only/database/postgresql/label/fast/

ruby/2.0.0/test/integration/host_js_test.rb:249

 The assertion is:

assert has_selector?("div", :text => "Updated hosts: changed environment")

 The danger with this selector is that it's trying to match a flash message sent after the request's completed, but it's attempting to

match the flash before it's displayed when it's in the HTML:

&lt;div class=&quot;flash hide notice&quot;&gt;Updated hosts: changed environment&lt;/div&gt;

 When the notify JS runs to display the message, it deletes the element and temporarily creates a new div elsewhere in the document

with a slightly different text.

&lt;ul class=&quot;ui-autocomplete ui-front ui-menu ui-widget ui-widget-content ui-corner-all&quot

; id=&quot;ui-id-1&quot; tabindex=&quot;0&quot; style=&quot;display: none;&quot;&gt;&lt;/ul&gt;&lt

;div class=&quot;jnotify-container&quot;&gt;&lt;div class=&quot;jnotify-notification jnotify-notif

ication-success&quot;&gt;&lt;div class=&quot;&quot;&gt;&lt;/div&gt;&lt;div class=&quot;foreman-ale

rt alert alert-success&quot;&gt;&lt;div&gt;&lt;/div&gt;&lt;span class=&quot;pficon pficon-ok&quot;

&gt;&lt;/span&gt;&lt;strong&gt;Success: &lt;/strong&gt;Updated hosts: changed environment&lt;/div&

gt;&lt;/div&gt;&lt;/div&gt;&lt;/body&gt;&lt;/html&gt;

 And then when the flash disappears, so does the element and any trace of the message. It's probably best to test success and the

flash in a different way.

Associated revisions

Revision ca9bf61b - 07/21/2016 05:17 AM - Dominic Cleal

fixes #15762 - move flash testing out of integration test

The flash div is only present momentarily before jnotify removes the

element and re-displays it as a popup, so only check that it's set in

the response from functional tests.

History

#1 - 07/21/2016 03:52 AM - The Foreman Bot

05/18/2024 1/2



- Status changed from Assigned to Ready For Testing

- Pull request https://github.com/theforeman/foreman/pull/3665 added

#2 - 07/21/2016 06:02 AM - Dominic Cleal

- Status changed from Ready For Testing to Closed

- % Done changed from 0 to 100

Applied in changeset ca9bf61b6bfbf04095a6034b11497edf0f16f309.

#3 - 07/21/2016 06:05 AM - Dominic Cleal

- translation missing: en.field_release set to 160
